/* Create a new thread, starting from start_routine(), called with
 * argument arg, and put the thread identifier in thread.  The POSIX
 * call has yet another parameter, the thread attributes, but we
 * want to avoid unnecessary complication (?) */
int lgd_thread_create(lgd_thread_t *thread,
                      void *(*start_routine)(void *),
                      void *arg);

/* Return the thread identifier of the current thread */
lgd_thread_t lgd_thread_self(void);

/* Test whether two thread identifiers are equal */
int lgd_thread_equal(lgd_thread_t thread1,lgd_thread_t thread2);

/* Initialize a new mutex.  The mutex object is of type
 * lgd_thread_mutex_t */
int lgd_thread_mutex_init(lgd_thread_mutex_t *mutex);

/* Lock a mutex, blocking until it is free */
int lgd_thread_mutex_lock(lgd_thread_mutex_t *mutex);

/* Lock a mutex if possible, but don't block; return EBUSY if the
 * mutex is being used */
int lgd_thread_mutex_trylock(lgd_thread_mutex_t *mutex);

/* Free a mutex */
int lgd_thread_mutex_unlock(lgd_thread_mutex_t *mutex);
