/* This file is part of Legendes II */
/* Copyright (c) 1998 by
 *   Philippe Clavel (philippe.clavel@supelec.fr)
 *   David Madore (david.madore@ens.fr) */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* File test.c */
/* This file is used for writing simple test programs of the library
 * functions. */

#include <stdio.h>

#include "lgd0.h"
#include "config.h"
#include "lgdlib.h"
#include "legasm.h"

lgd_filedesc_t f;

int
main(void)
{
  int i;
  lgd_open(1,&f,"test.lgc",OPEN_TRUNCATE);
  lgd_write_littleendian_int32(i,f,0x00000181); /* mov 1,r81 */
  lgd_write_littleendian_int32(i,f,0x00018181); /* add 1,r81,r81 */
  lgd_write_littleendian_int32(i,f,0x00000182); /* mov 1,r82 */
  lgd_write_littleendian_int32(i,f,0x00018282); /* add 1,r82,r82 */
  lgd_write_littleendian_int32(i,f,0x24828110); /* cmpae r82,r81,r10 */
  lgd_write_littleendian_int32(i,f,0x3610000d); /* bnz r10,+000d */
  lgd_write_littleendian_int32(i,f,0x00008121); /* mov r81,r21 */
  lgd_write_littleendian_int32(i,f,0x00008222); /* mov r82,r22 */
  lgd_write_littleendian_int32(i,f,0x02212221); /* sub r21,r22,r21 */
  lgd_write_littleendian_int32(i,f,0x24212210); /* cmpae r21,r22,r10 */
  lgd_write_littleendian_int32(i,f,0x36100003); /* bnz r10,+0003 */
  lgd_write_littleendian_int32(i,f,0x00002130); /* mov r21,r30 */
  lgd_write_littleendian_int32(i,f,0x00002221); /* mov r22,r21 */
  lgd_write_littleendian_int32(i,f,0x00003022); /* mov r30,r22 */
  lgd_write_littleendian_int32(i,f,0x21002210); /* cmpneq 0,r22,r10 */
  lgd_write_littleendian_int32(i,f,0x3610fff8); /* bnz r10,-0008 */
  lgd_write_littleendian_int32(i,f,0x20012110); /* cmpeq 1,r21,r10 */
  lgd_write_littleendian_int32(i,f,0x3610fff1); /* bnz r10,-000f */
  lgd_write_littleendian_int32(i,f,0x3200ffee); /* jmp -0012 */
  lgd_write_littleendian_int32(i,f,0xf0000001); /* srvc 1 */
  lgd_write_littleendian_int32(i,f,0x3200ffec); /* jmp -0014 */
  lgd_close(1,f);
  legasm_init("test.lgc");
  legasm_run(0,0);
}
